def backtracking_basic(csp, assignment):
    
    if csp.is_complete(assignment):
        return True
    
    X = assignment.index(None)
    D = [i for i in range(csp.n)]
    
    for v in D:
        
        assignment[X] = v
        
        if csp.is_valid(assignment):
            res = backtracking_basic(csp, assignment)
            if res == True:
                return True
            
        assignment[X] = None
    
    return False


def backtracking_fc(csp, assignment, domains):
    
    if csp.is_complete(assignment):
        return True
    
    X = assignment.index(None)
    D = domains[X]
    
    for v in D:
        
        assignment[X] = v
        new_domains = csp.forward_check(assignment, domains)
        
        if all(len(domain) > 0 for domain in new_domains):
            res = backtracking_fc(csp, assignment, new_domains)
            if res == True:
                return True
            
        assignment[X] = None
    
    return False


def backtracking_fc_mcv(csp, assignment, domains):
    
    if csp.is_complete(assignment):
        return True
    
    X = csp.select_variable(assignment, domains)
    D = domains[X]
    
    for v in D:
        
        assignment[X] = v
        new_domains = csp.forward_check(assignment, domains)
        
        if all(len(domain) > 0 for domain in new_domains):
            res = backtracking_fc_mcv(csp, assignment, new_domains)
            if res == True:
                return True
            
        assignment[X] = None
    
    return False